# Python imports
import sys
import os
import time
import traceback

# CORBA imports
from omniORB import CORBA, PortableServer, BiDirPolicy
import CosNaming

# IDL imports
import cb, cb__POA

use_bidir = False

orb = None
root_poa = None
callback_poa = None


class CallbackImpl(cb__POA.CallBack):
    def __init__(self):
        pass

    def call_back(self, message):
        print "Got called with this message:", message

def run_client():

    args = sys.argv[:]

    global use_bidir
    if "-b" in args:
        use_bidir = True

    if use_bidir:
        args.append("-ORBofferBiDirectionalGIOP")
        args.append("1")
        args.append("-ORBacceptBiDirectionalGIOP")
        args.append("1")
        args.append("-ORBserverTransportRule")
        args.append("* tcp,unix,ssl,bidir")
        args.append("-ORBclientTransportRule")
        args.append("* unix,tcp,ssl,bidir")

    # Initialise the ORB
    global orb
    orb = CORBA.ORB_init(args, CORBA.ORB_ID)

    # Find the root POA
    global root_poa
    root_poa = orb.resolve_initial_references("RootPOA")
    poa_man = root_poa._get_the_POAManager()
    poa_man.activate()

    global callback_poa
    if use_bidir:
        policies = [ BiDirPolicy.BidirectionalPolicy(BiDirPolicy.BOTH) ]
        callback_poa = root_poa.create_POA("BiDirPOA", poa_man, policies)
        callback_pman = callback_poa._get_the_POAManager()
        callback_pman.activate()
    else:
        callback_poa = root_poa

    # create callback 
    server_i = CallbackImpl()

    # activate it with a POA
    if use_bidir:
        id = callback_poa.activate_object(server_i)

    server_ref = server_i._this()

    # find the RootFinder on the server.
    success = 0
    for i in range(10):
        host = "localhost"
        port = 5024
        urlstr = "corbaloc::%s:%d/CallbackServerRoot" % (host, port)
        try:
            obj = orb.string_to_object(urlstr)
            rootfinder = obj._narrow(cb.RootFinder)
            # try a call to it.
            cbserver = rootfinder.get()
            cbserver.one_time(server_ref, "Just say YES to Python")
            success += 1
        except Exception, e:
            print sys.exc_info()
            traceback.print_exc(sys.exc_info()[2])
        time.sleep(1)
    print "Succeeded: %d" % success

if __name__ == '__main__':
    run_client()
